/**
 * generated by Xtext 2.16.0
 */
package org.xtext.ungs.drake.drake.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.xtext.ungs.drake.drake.DrakePackage;
import org.xtext.ungs.drake.drake.LinearExpression;
import org.xtext.ungs.drake.drake.LinearInequation;
import org.xtext.ungs.drake.drake.Variable;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Linear Inequation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.ungs.drake.drake.impl.LinearInequationImpl#getLinearExpression <em>Linear Expression</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.impl.LinearInequationImpl#getSimbol <em>Simbol</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.impl.LinearInequationImpl#getVarInequality <em>Var Inequality</em>}</li>
 *   <li>{@link org.xtext.ungs.drake.drake.impl.LinearInequationImpl#getIntInequality <em>Int Inequality</em>}</li>
 * </ul>
 *
 * @generated
 */
public class LinearInequationImpl extends MinimalEObjectImpl.Container implements LinearInequation
{
  /**
   * The cached value of the '{@link #getLinearExpression() <em>Linear Expression</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLinearExpression()
   * @generated
   * @ordered
   */
  protected LinearExpression linearExpression;

  /**
   * The default value of the '{@link #getSimbol() <em>Simbol</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSimbol()
   * @generated
   * @ordered
   */
  protected static final String SIMBOL_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getSimbol() <em>Simbol</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSimbol()
   * @generated
   * @ordered
   */
  protected String simbol = SIMBOL_EDEFAULT;

  /**
   * The cached value of the '{@link #getVarInequality() <em>Var Inequality</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarInequality()
   * @generated
   * @ordered
   */
  protected Variable varInequality;

  /**
   * The default value of the '{@link #getIntInequality() <em>Int Inequality</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIntInequality()
   * @generated
   * @ordered
   */
  protected static final int INT_INEQUALITY_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getIntInequality() <em>Int Inequality</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIntInequality()
   * @generated
   * @ordered
   */
  protected int intInequality = INT_INEQUALITY_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LinearInequationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DrakePackage.Literals.LINEAR_INEQUATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public LinearExpression getLinearExpression()
  {
    return linearExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetLinearExpression(LinearExpression newLinearExpression, NotificationChain msgs)
  {
    LinearExpression oldLinearExpression = linearExpression;
    linearExpression = newLinearExpression;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION, oldLinearExpression, newLinearExpression);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLinearExpression(LinearExpression newLinearExpression)
  {
    if (newLinearExpression != linearExpression)
    {
      NotificationChain msgs = null;
      if (linearExpression != null)
        msgs = ((InternalEObject)linearExpression).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION, null, msgs);
      if (newLinearExpression != null)
        msgs = ((InternalEObject)newLinearExpression).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION, null, msgs);
      msgs = basicSetLinearExpression(newLinearExpression, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION, newLinearExpression, newLinearExpression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSimbol()
  {
    return simbol;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSimbol(String newSimbol)
  {
    String oldSimbol = simbol;
    simbol = newSimbol;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DrakePackage.LINEAR_INEQUATION__SIMBOL, oldSimbol, simbol));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Variable getVarInequality()
  {
    return varInequality;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetVarInequality(Variable newVarInequality, NotificationChain msgs)
  {
    Variable oldVarInequality = varInequality;
    varInequality = newVarInequality;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY, oldVarInequality, newVarInequality);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVarInequality(Variable newVarInequality)
  {
    if (newVarInequality != varInequality)
    {
      NotificationChain msgs = null;
      if (varInequality != null)
        msgs = ((InternalEObject)varInequality).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY, null, msgs);
      if (newVarInequality != null)
        msgs = ((InternalEObject)newVarInequality).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY, null, msgs);
      msgs = basicSetVarInequality(newVarInequality, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY, newVarInequality, newVarInequality));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getIntInequality()
  {
    return intInequality;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIntInequality(int newIntInequality)
  {
    int oldIntInequality = intInequality;
    intInequality = newIntInequality;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DrakePackage.LINEAR_INEQUATION__INT_INEQUALITY, oldIntInequality, intInequality));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION:
        return basicSetLinearExpression(null, msgs);
      case DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY:
        return basicSetVarInequality(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION:
        return getLinearExpression();
      case DrakePackage.LINEAR_INEQUATION__SIMBOL:
        return getSimbol();
      case DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY:
        return getVarInequality();
      case DrakePackage.LINEAR_INEQUATION__INT_INEQUALITY:
        return getIntInequality();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION:
        setLinearExpression((LinearExpression)newValue);
        return;
      case DrakePackage.LINEAR_INEQUATION__SIMBOL:
        setSimbol((String)newValue);
        return;
      case DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY:
        setVarInequality((Variable)newValue);
        return;
      case DrakePackage.LINEAR_INEQUATION__INT_INEQUALITY:
        setIntInequality((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION:
        setLinearExpression((LinearExpression)null);
        return;
      case DrakePackage.LINEAR_INEQUATION__SIMBOL:
        setSimbol(SIMBOL_EDEFAULT);
        return;
      case DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY:
        setVarInequality((Variable)null);
        return;
      case DrakePackage.LINEAR_INEQUATION__INT_INEQUALITY:
        setIntInequality(INT_INEQUALITY_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DrakePackage.LINEAR_INEQUATION__LINEAR_EXPRESSION:
        return linearExpression != null;
      case DrakePackage.LINEAR_INEQUATION__SIMBOL:
        return SIMBOL_EDEFAULT == null ? simbol != null : !SIMBOL_EDEFAULT.equals(simbol);
      case DrakePackage.LINEAR_INEQUATION__VAR_INEQUALITY:
        return varInequality != null;
      case DrakePackage.LINEAR_INEQUATION__INT_INEQUALITY:
        return intInequality != INT_INEQUALITY_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (simbol: ");
    result.append(simbol);
    result.append(", intInequality: ");
    result.append(intInequality);
    result.append(')');
    return result.toString();
  }

} //LinearInequationImpl
